(* $Id: common.ml,v 1.3 1996/12/01 15:14:33 garrigue Exp $ *)

type 'a option =
    None
  | Some of 'a
;;

type constant =
    Cint of int
  | Cchar of char
  | Cfloat of float
;;

type dirflag = Upto | Downto
and access = Mutable | Immutable | Forbidden
;;

type ident = { name: string ; index: int} ;;

let id_count = ref 0;;
let new_id name = incr id_count; {name = name; index = !id_count};;

let same_id id1 id2 = id1.index = id2.index
and compare_id id1 id2 = id1.index - id2.index
;;
