(defconst minimal-font-lock-keywords
  (list
;inferior
    '("^[#-]" . font-lock-comment-face)
;comments
   '("\\(^\\|[^\"]\\)\\((\\*[^*]*\\*+\\([^)*][^*]*\\*+\\)*)\\)"
     2 font-lock-comment-face)
;character literals
   (cons (concat "'\\(\\\\\\([ntbr'\\]\\|[0-9][0-9][0-9]\\)\\|.\\)'"
		 "\\|\"[^\"\\]*\\(\\\\\\(.\\|\n\\)[^\"\\]*\\)*\"")
	 'font-lock-string-face)
;operators
   (cons (concat "\\<poly\\|mono\\|use\\>"
		 "\\|<[>= \t]\\|[ \t]>\\|!=\\|==\\|::\\|@\\|<[A-Za-z0-9]*>")
	 'font-lock-type-face)
;labels and assignments
   '("\\(\\<[A-Za-z][A-Za-z0-9_']*:\\)\\([^:=]\\|\\'\\|$\\)" 1
     font-lock-variable-name-face)
   '(":?=>?\\|<-\\||"
     . font-lock-variable-name-face)
;definition
   '("\\<\\(and\\|fun\\|hide\\|va[lr]\\|type\\|exception\\)\\>"
     . font-lock-keyword-face)
;blocking
;control
   (cons (concat
	  "\\<\\(begin\\|case\\|end\\|mutable\\|of\\|let\\|in\\)\\>\\|->"
	  "\\|\\<\\(do\\(wnto\\)?\\|else\\|f\\(or\\|n\\)\\|if\\|then"
	  "\\|while\\)\\>")
	 'font-lock-reference-face) 
   '("\\<or\\>\\|&" . font-lock-function-name-face)
   '("\\<raise\\>" . font-lock-comment-face)))

(defun minimal-mode nil
  "Keywords for MiniMAL."
  (interactive)
  (setq font-lock-keywords minimal-font-lock-keywords)
  (setq font-lock-no-comments t)
  (font-lock-mode 1)
  (font-lock-fontify-buffer))
