(* $Id: misc.ml,v 1.1 1996/12/01 15:15:02 garrigue Exp $ *)

let string_of_array arr =
  let len = vect_length arr in
  let s = make_string len ` ` in
  for i = 0 to len - 1 do s.[i] <- arr.(i) done;
  s
;;

let array_of_string s =
  let len = string_length s in
  let arr = make_vect len ` ` in
  for i = 0 to len - 1 do arr.(i) <- s.[i] done;
  arr
;;

let rec nth n l =
  if n = 0 then hd l else nth (n-1) (tl l)
;;

let rec flatten = function
    [] -> []
  | l :: ll -> l @ flatten ll
;;

let split_last l =
  match rev l with
    last :: rl -> rev rl, last
  | [] -> raise (Invalid_argument "misc__split_last")
;;

let rec do_list3 f l1 l2 l3 =
  match l1,l2,l3 with
    [],[],[] -> ()
  | a::l1, b::l2, c::l3 -> f a b c; do_list3 f l1 l2 l3
  | _ -> raise (Invalid_argument "do_list3")
;;

let rec add_bindings l map =
  it_list (fun map (key,data) -> map__add key data map) map l
;;
